Program NiutonBinomCalculator_V2;
Const limit1 = 1; //apatinis laipsnio n rezis
      limit2 = 12;//virsutinis laipsnio n rezis

Function factorial(n :Byte) :LongInt; //Funkcija skaicuojanti laipsnio n faktoriala
Var i :Byte;
  Begin
   factorial := 1;
   If n = 0 then factorial := 1 // 0! = 1 ,tikrina ar skaicius = 0 jei taip faktorialas = 1
            else For i := n downto 1 do
                   factorial := factorial * i;
  End;
  
Function combination( j, n :Byte) :Integer;//Funkcija paskaiciuojanti deriniu skaiciu is n elementu po j elementu.
  Begin
    combination := factorial(n) div (factorial(j) * factorial(n - j));
  End;
  
Procedure writer(n, j :Byte);// Procedura isvedanti i ekrana a ir b reikiamam laipsnyje, sudeliojanti + zenklus
Var i :Byte;
  Begin
    For i := 1 to j do  //J - skaiciaus a laipsnis. Jei j = 0 tai yra a laipsnyje 0 = 1, tada a nerasome tesiog praleidziame.
      Write('a');
    For i := 1 to n - j  do  //n-j - skaiciaus b laipsnis. Jei n - j = 0 tai yra b laipsnyje 0 = 1, tada b nerasome.
      Write('b');
      If n <> j  then Write(' + ');//kada n = j yra reiskinio pabaiga todel zenklo + nerasome.
   End;
  
Procedure combChecker(n :Byte);// Procedura isveda i ekrana deriuniu skaiciu (binomini koeficenta)  kur tai butina
Var j :Byte;
  Begin
    For j := 0 to n do
      Begin
       If combination(j, n) <> 1 then Write(combination(j, n)) ; //Jei binominis koeficentas <> 1 jis isvedamas i ekrana
       writer(n, j);
      End;
  End;

Procedure simbolValid( Var strn :String); //Patikrina ar ivestas simbolis yra skaicius
Var i, ind :Integer; //Ind - indikatorius, igauna reiksme > 0 kai ivestas simbolis nera sakaicius
  Begin
    Repeat
    ind := 0;
    For i := 1 to Length(strn) do
      If (strn[i] < '0') or ( strn[i] > '9') then ind := ind + 1;
    If ind <> 0 then
      Begin
        WriteLn('Jusu ivestas simbolis nera skaicius/ne naturalus skaicius') ;
        WriteLn('Iveskite n laipsni dar karta:');
        ReadLn(strn);
      End;
    Until (ind = 0);
 End;

Procedure numberValid( Var strn :String );//Patikrina ar laipsnis n atitinka nurodytus rezius
Var n :LongInt;
  Begin
    Repeat
      Val(strn, n);
      If (n < limit1) or (n > limit2) then // tikrinama ar laipsnis atitinka rezius
        Begin
          WriteLn('Laipsnis n turi buti didesnis uz ',limit1,' mazesnis uz ',limit2,'.' ) ;
          WriteLn('Iveskite n laipsni dar karta:');
          ReadLn(strn);
          simbolValid(strn);// po naujo laipsnio ivedimo tikrinama ar ivestas simbolis skaicius
        End;
     Until (n >= limit1) and (n <= limit2);
  End;
  
Var i, n :Byte;
    strn :String; //strn - eilutes tipo laipsnis n
BEGIN
  WriteLn();
  WriteLn('     NIUTONO BINOMO FORMULE');
  Write(' ',chr(218));
  For i :=1 to 29 do
    Write(chr(196));
  Write(chr(191));
  writeln();
  WriteLn(' ',chr(179),'         _n_                 ',chr(179));
  WriteLn(' ',chr(179),'      n  \     n   j  j - n  ',chr(179));
  WriteLn(' ',chr(179),' (a+b) = /   C   a   b       ',chr(179));
  WriteLn(' ',chr(179),'         ---   j             ',chr(179));
  WriteLn(' ',chr(179),'         j=0                 ',chr(179));
  WriteLn(' ',chr(179),'                             ',chr(179));
  Write(' ',chr(192));
  For i :=1 to 29 do
    Write(chr(196));
  WriteLn(chr(217));
  
  WriteLn(' Isskaidom (a+b) laipsnije: n pagal Niutono Binomo formule.');
  WriteLn(' Iveskite naturaluji laipsni n ne didesni uz 12:');
  Readln(strn);
  simbolValid( strn);
  numberValid(strn);
  Val(strn,n);
  Write('(a+b) laipsnyje ',n,' = ');
  combChecker(n);
  Readln();
END.

{Programa rase , E-mail  2008.11.12
Programa iskaido reiskini (a+b) laipsnyje n pagal Niutono binomo formule, n - neturalus skaicius ne didesnis uz 12
(jei prireiktu galima isplest rezius).

Funkcijos:
 1.factorial - paskaiciuoja skaiciaus faktoriala,(0! = 1 pagal apibriezima)
 2.combination - paskaiciuja deriniu skaiciu  is n elementu po j, pagal formule n! / (j! / (n - j)!)
 
Proceduros:
 1.writer - Procedura rasanti a ir b reikiamam laipsnyje, raso + zenkla
 2.numberValid - Patikrina ar laipsnis n atitinka nurodytus rezius
 3.simbolValid - Patikrina ar ivestas simbolis yra skaicius
 4.combChecker - Procedura isveda i ekrana deriuniu skaiciu (binomini koeficenta)  kur tai butina, patikrina ar
 binominis koeficentas <> 1, jei taip, isveda ji i ekrana.
Pastabos
 V2 Pakeitimai:
  1. Procedura writer isskaidita i 2 proceduras: writer ir combChecker.
  2. Ivedus neatitinkanti reziu skaiciu, pakartotinai ji ivedant tikrinama ne tik ar jis atitinka rezius, bet
  ir, ar jis yra skaicius o ne raide ar kitas netinkamas simbolis.
  3.Pakeisti komentarai
Programa parasyta ir veikia Windows XP aplinkoje}
